
#define SYMBOL(tab,sym) (((tab) << 8) + (sym))

#define SYMTAB(symbol)  ((symbol) >> 8)
#define SYM(symbol)     ((byte) (symbol))

#define SYM_DIGI    '#'
#define SYM_BALLOON 'O'

#define SYMBOL_AREA     SYMBOL('\\', 'l')
#define SYMBOL_SIGNPOST SYMBOL('\\', 'm')

bool
	is_map_element(word symbol),
	is_digi_symbol(word symbol),
	is_mobile_symbol(word symbol),
	is_weather_symbol(word symbol),

	is_valid_symbol(word symbol),

	is_valid_sym(byte tab, byte sym),
	is_valid_sym_with_compression(byte tab, byte sym);

#if 0

/* alert - invalid code was generated from gcc, with the following */

#define JUST_WX SYMBOL('/',  '_')

#define oopsis(s) (SYM(s) == '#' || (SYM(s) == '_' && (s) != JUST_WX))

static int
foobarish(word w)
{
	if (oopsis(w))
		foobarish(w);
}
/* symbol 's' includes code (lsbyte) and table id (msbyte). macro danger. */

/* ._ and .W for weather */
#define is_weather_symbol(s) (SYM(s) == '_' || SYM(s) == 'W')

/* .# is digi and ._ is digi too but not /_ */
#define is_digi_symbol(s) (SYM(s) == '#' || (SYM(s) == '_' && SYMTAB(s) != '/'))

/* or is it a 'map feature' instead ? */
#define is_map_element(s) ((s) == SYMBOL_AREA || (s) == SYMBOL_SIGNPOST)

#endif

