
	section	.data
	align	1

_float_rad_to_mm
	dc.l	27501975
	dc.w	29

	section	.text
	align	1

_ld_double
	pshm z
	ais  #-8
	tsz

	xgex            ; float *f
	xgdy            ; flt_scale *scale

	ldd  1,x        ; sign[1] exponent[11] mantissa[...]
	anda # 0Fh
	oraa # 10h      ; implied 1.
	std  0,z
	lde  3,x
	ldaa 5,x
	rola
	role
	rolw 0,z
	rola
	role
	rolw 0,z        ; mantissa MSWord

	ldd  0,x
	lsrd
	lsrd
	lsrd
	lsrd
	andd # 07FFh
	subd # 30 + 1023

	bra  tail

_ld_float
	pshm z
	ais  #-8
	tsz

	xgex            ; float *f
	xgdy            ; flt_scale *scale

	ldab 1,x        ; sign[1] exponent[8] mantissa[23]
	orab # 80h      ; implied 1.
	clra
	std  0,z
	lde  2,x

	ldd  0,x
	asld
	tab
	clra
	subd # 23 + 127

tail
	ste  2,z        ; mantissa LSWord
	std  4,z        ; exponent
	stx  6,z        ; still needed for sign

	cpy  # 0
	beq  L1         ; no scale

	addd 4,y
	std  4,z
	xgdy            ; lea d 0,y
	tze
	jsr  _SCALE32
L1
	ldd  4,z
	tze
	jsr  _shift_dword

	lde  0,z
	ldd  2,z

	ldx  6,z
	tst  0,x
	bge  L2
	jsr  _lneg
L9
	ais  #+8
	pulm z
	rts

_shift_dword

	tstd
	beq  L4
	blt  L3
	cpd  # 32
	bge  L2
	jmp  _ASLx
L3
	cpd  #-32
	ble  L2
	negd
	jmp  _LSRx
L2
	xgex
	clrw 0,x
	clrw 2,x
L4
	rts

